
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用IconFont减小iOS应用体积 / iVAN</title>

    <meta name="description" content="使用IconFont减小iOS应用体积 点点iOS项目本身功能较多,导致应用体积也比较大.但是手机淘宝集成时对插件包大小有要求.因此点点iOS团队使用了一些方法来缩小插件包体积,比如部分业务只放在独立版.图片压缩(PNG大图转成JPG,ImageAlpha与ImageOptim对PNG图片压缩).部分大图安装后从网络下载.近期小虎提出使用IconFont技术减小图片体积,让我在这这方面做了一些研究.最终将IconFont应用在iOS项目中,取得了不错的效果.如果你懒得看这么长的文,那么直接去看IconFont项目吧. 简介 IconF">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用IconFont减小iOS应用体积</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>点点iOS项目本身功能较多，导致应用体积也比较大。但是手机淘宝集成时对插件包大小有要求。因此点点iOS团队使用了一些方法来缩小插件包体积，比如部分业务只放在独立版、图片压缩（PNG大图转成JPG，ImageAlpha与ImageOptim对PNG图片压缩）、部分大图安装后从网络下载。近期小虎提出使用IconFont技术减小图片体积，让我在这这方面做了一些研究。最终将IconFont应用在iOS项目中，取得了不错的效果。如果你懒得看这么长的文，那么直接去看<a href="https://github.com/JohnWong/IconFont" rel="external nofollow noreferrer">IconFont项目</a>吧。</p>
<h2>简介</h2>
<p>IconFont技术起源于Web领域的Web Font技术。随着时间的推移，网页设计越来越漂亮。但是电脑预装的字体远远无法满足设计者的要求，于是Web Font技术诞生了。一个英文字库并不大，通过网络下载字体，完成网页的显示。有了Web Font技术，大大提升了设计师的发挥空间。</p>
<p>网页设计中图标需要适配多个分辨率，每个图标需要占用一次网络请求。于是有人想到了用Web Font的方法来解决这两个问题，就是IconFont技术。将矢量的图标做成字体，一次网络请求就够了，可以保真缩放。解决这个问题的另一个方式是图片拼合的Sprite图，他们之间的对比参考<a href="http://www.jontetzlaff.com/blog/2013/04/29/image-sprites-vs-web-icon-fonts/" rel="external nofollow noreferrer">Image Sprites vs Web IconFonts</a>。</p>
<p>在iOS项目中应用IconFont主要目的是缩小图片所占体积。尝试用<a href="https://www.codeandweb.com/texturepacker/" rel="external nofollow noreferrer">TexturePacker</a>将点点的七百多图片拼合为Sprite图，体积只减少了几十KB，还未计算需要增加的代码量，实际帮助很小。而IconFont在这方便帮助很大。我们在项目中应用IconFont后取得了不错的效果，后面会做详细的体积减小效果统计。目前新功能开发中的图片都尽量采用IconFont来实现。IconFont应用在iOS中的优点和缺点如下：</p>
<h3>优点</h3>
<ul>
<li>减小体积，字体文件比图片要小</li>
<li>图标保真缩放，解决2x/3x乃至将来的nx图问题</li>
<li>方便更改颜色大小，图片复用</li>
</ul>
<h3>缺点</h3>
<ul>
<li>只适用于<code>纯色icon</code></li>
<li>使用unicode字符难以理解</li>
<li>需要维护字体库</li>
</ul>
<h2>字体管理</h2>
<p>字体管理方式分为两种：在线管理（<a href="http://www.iconfont.cn/" rel="external nofollow noreferrer">iconfont.cn</a>）和FontForge工具。在实际应用中我们采用了在线管理的方式。</p>
<h3>在线管理</h3>
<p><a href="http://www.iconfont.cn/" rel="external nofollow noreferrer">iconfont.cn</a>网站可以方便地在线管理字库，使用方法参考<a href="http://iconfont.cn/help/platform.html" rel="external nofollow noreferrer">iconfont.cn帮助</a>。在帮助中为设计师提供了<code>图标制作说明</code>和<code>模版文件下载</code>。帮助中给出了iOS应用的方法，只是简单地用UILabel显示图标，还远不够好用，在<code>应用于客户端</code>一节我们介绍如何更灵活地应用。</p>
<p>考虑到与设计师的协作、工程师之间的协作，最终我们采用了这种管理方式。协作过程中角色包括设计师、字体管理者（某个开发者兼任）、开发者。整个流程环节包括：上传、分发、加入工程、开发。</p>
<p>上传：在<a href="http://www.iconfont.cn/" rel="external nofollow noreferrer">iconfont.cn</a>网站上创建一个共用项目，设计师将图标上传这个项目中，并调整好图标的位置。建议在图标的上下左右边界留出一点空白，以确保图标显示完整。iconfont.cn上的字体一般在四个方向留下1/16的空白，如下图所示。修改图标位置大小的方法是在上传的图标上悬停，点击弹出的编辑按钮。编辑窗口可以调整图标的大小、位置、旋转角度。缩放和移动的粒度通过右上角网格尺寸来控制，例如填写16时一次调整粒度是图标的1/16。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG4tam9obndvbmcucWJveC5tZS9pbWFnZXMvMjAxNS0wNC0wMy11c2luZy1pY29uLWZvbnQtaW4taW9zLWljb25mb250LWVkaXQucG5n.jpg"></p>
<p>分发： iOS与Android团队分别建立各自的项目，由各自的字体管理者将共用项目中各自用到的图标导入到建立的项目中。以后有新图标需要加入时，分发的工作也可以由用到新图标的开发者自行加入导入项目。</p>
<p>加入工程：每次更新图标后由字体管理者下载字体，加入到工程中并提交到工程的版本控制系统。如果希望更进一步压缩字体体积，可以用FontForge简化字体（用FontForge打开字体，Ctrl+A，Element -&gt; Simplify -&gt; Simplify）。</p>
<p>开发：开发人员使用字体中的图标完成开发。开发这一步可以与加入工程同时进行。因为分发结束后图标的Unicode码已经可以在网站上看到，开发可以先行开发，只是暂时看不到结果。</p>
<h3>FontForge工具</h3>
<p><a href="https://github.com/fontforge/fontforge" rel="external nofollow noreferrer">FontForge</a>是一个自由免费的工具，支持Linux/Mac/Windows（Mac下基于X11，Windows下基于MSYS）。不仅易于上手适合初学者学习字型设计，而且也提供了一系列高级工具。下图为FontForge的主界面和绘制窗口。更详细的帮助参考<a href="http://designwithfontforge.com/" rel="external nofollow noreferrer">Design With FontForge</a>。使用FontForge制作字体的过程如下。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG4tam9obndvbmcucWJveC5tZS9pbWFnZXMvMjAxNS0wNC0wMy11c2luZy1pY29uLWZvbnQtaW4taW9zLWZvbnRmb3JnZS1vdmVydmlldy5wbmc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG4tam9obndvbmcucWJveC5tZS9pbWFnZXMvMjAxNS0wNC0wMy11c2luZy1pY29uLWZvbnQtaW4taW9zLWZvbnRmb3JnZS5wbmc=.jpg"></p>
<h4>1. 调整配置</h4>
<p>为了确保字体正确显示，需要调整字体文件的一些参数。</p>
<ul>
<li>字体名称：FontForge -&gt; Element -&gt; Font Info... -&gt; PS Names，将PS Names、Family Name和Name For Humans三个属性改为你想使用的字体名称。</li>
</ul>
<p>Note. 使用字体时一般可以根据字体名称取到字体。这个字体名称存储在字体文件内部，与字体的文件名无关。在Mac下查看字体名称最简单的方法就是双击字体用默认打开程序Font Book打开，窗口标题栏会显示字体名称。为了定制取字体时用到的字体名称，我们需要修改字体的名称。建议将PS Names下的PS Names、Family Name和Name For Humans三个属性都修改了，以避免与项目中其他字体冲突。只改第一个或者前两个可能出现异常，比如应用切到后台再切回来会出现其中一个字体显示异常的问题。</p>
<ul>
<li>字体大小：FontForge -&gt; Element -&gt; Font Info... -&gt; General。建议配置：</li>
<li>
<pre><code>Ascent: 812
Descent: 212
EM Size: 1024</code></pre>
</li>
</ul>
<ul>
<li>字体偏移量：FontForge -&gt; Element -&gt; Font Info... -&gt; OS/2 -&gt; Metrics，Is Offset勾选，并且相应的输入框填0。</li>
</ul>
<h4>2. 矢量文件导出为SVG</h4>
<p><a href="https://github.com/fontforge/fontforge" rel="external nofollow noreferrer">FontForge</a>支持导入的常用矢量图格式有EPS、SVG、PDF等。需要将AI文件转化为SVG文件后导入（AI文件转为EPS后导入，程序崩溃了。打开EPS文件直接粘贴，不能正常显示。）。一些导出SVG的优化选项参考<a href="http://www.adobe.com/inspire/2013/09/exporting-svg-illustrator.html" rel="external nofollow noreferrer">AI导出SVG的优化</a>。</p>
<h4>3. 将SVG导入字库</h4>
<ul>
<li>双击放置图标的字符，打开字型绘制窗口</li>
<li>导入SVG文件，File -&gt; Import...，类型选择SVG</li>
<li>适当调整导入的曲线的位置，最终显示区域为窗口中央的正方形</li>
<li>完成后关闭字形绘制窗口</li>
</ul>
<h4>4. 添加填充字形</h4>
<p>目前发现如果没有字符达到Ascent与Descent两个位置，字型位置会下移。暂时解决方法是选择一个字符填充到这两个位置，即使超过也没关系。我们选择了通常会填充的字符X。缺少这个字符的字体使用在网页上，XP上的Safari浏览器会引起操作系统崩溃。</p>
<h4>5. 导出字体文件</h4>
<p>File -&gt; Generate Fonts。本文始终使用TrueType字体展开研究，所以类型选择TrueType。iOS也支持odf字体，有兴趣的读者可以尝试。</p>
<h2>应用于客户端</h2>
<h3>字体注册</h3>
<p>iOS中使用自定义字体，将字体加入项目后，还需要注册字体。注册的方式有两种：－ 在Info.plist中声明"Fonts provided by application" － 调用API来注册。考虑到需要支持独立版和插件版，调用API注册更加方便。字体注册和获取的代码如下：</p>
<pre><code>+ (void)registerFontWithURL:(NSURL *)url {
    NSAssert([[NSFileManager defaultManager] fileExistsAtPath:[url path]], @"Font file doesn't exist");
    CGDataProviderRef fontDataProvider = CGDataProviderCreateWithURL((__bridge CFURLRef)url);
    CGFontRef newFont = CGFontCreateWithDataProvider(fontDataProvider);
    CGDataProviderRelease(fontDataProvider);
    CTFontManagerRegisterGraphicsFont(newFont, nil);
    CGFontRelease(newFont);
}

+ (UIFont *)fontWithSize:(CGFloat)size {
    UIFont *font = [UIFont fontWithName:[self fontName] size:size];
    if (font == nil) {
        [self registerFontWithURL: [[NSBundle mainBundle] URLForResource:[self fontName] withExtension:@"ttf"]];
        font = [UIFont fontWithName:[self fontName] size:size];
        NSAssert(font, @"UIFont object should not be nil, check if the font file is added to the application bundle and you're using the correct font name.");
    }
    return font;
}</code></pre>
<h3>字体应用方式</h3>
<p>可能的应用方式：</p>
<ul>
<li>UILabel作为Icon</li>
<li>UIButton的titleLabel作为Icon</li>
<li>根据字体生成UIImage</li>
</ul>
<p>在实际项目中，我们采用了第三种方式。因为生成UIImage更加灵活，可以替代UIImage，而不是更外层的UIImageView。我们采用Category的方式为UIImage添加方法，根据图片大小、颜色和Unicode码来生成并返回图片。这个方法的代码如下，其中TBCityIconInfo是一个存储图片信息类：</p>
<pre><code>+ (UIImage *)iconWithInfo:(TBCityIconInfo *)info {
    CGFloat size = info.size;
    CGFloat scale = [UIScreen mainScreen].scale;
    CGFloat realSize = size * scale;
    UIFont *font = [TBCityIconFontUtil fontWithSize:realSize];
    UIGraphicsBeginImageContext(CGSizeMake(realSize, realSize));
    CGContextRef context = UIGraphicsGetCurrentContext();

    if ([info.text respondsToSelector:@selector(drawAtPoint:withAttributes:)]) {
        [info.text drawAtPoint:CGPointZero withAttributes:@{NSFontAttributeName:font, NSForegroundColorAttributeName: info.color}];
    } else {
        CGContextSetFillColorWithColor(context, info.color.CGColor);
        [info.text drawAtPoint:CGPointMake(0, 0) withFont:font];
    }

    UIImage *image = [UIImage imageWithCGImage:UIGraphicsGetImageFromCurrentImageContext().CGImage scale:scale orientation:UIImageOrientationUp];
    UIGraphicsEndImageContext();

    return image;
}</code></pre>
<h3>API设计</h3>
<p><a href="https://github.com/AlexDenisov/FontasticIcons" rel="external nofollow noreferrer">FontasticIcons</a>对API的设计是，预先定义方法，方法名包含图片名称。在运行时为类添加这些方法的实现。图片名称到Unicode字符的映射，采用iOS本地化文件。映射文件编译的时候会压缩，不会占用过多体积。</p>
<p>我们通过一个类TBCityIconInfo来保存一张图片的大小、颜色和Unicode码。在一个文件中定义了一些宏，在这些宏中做这些信息的组合。这样字体定义放在一起方便查找管理，用到图片的地方只需要放这个宏定义即可。</p>
<pre><code>#define TBCityIconInfoMake(text, imageSize, imageColor) [TBCityIconInfo iconInfoWithText:text size:imageSize color:imageColor]
#define kTBCityIconHomeTabMe TBCityIconInfoMake(@"\U0000e61c", 24,  HEXCOLOR(0xf4824f))</code></pre>
<h2>效果分析</h2>
<h3>体积减小效果</h3>
<p>我们对项目的图片做了一些替换，目前替换了69张2x图，同时减少67张3x图。为了计算这些图片打包后实际所占体积，我们建立了一个空工程，通过执行Archive、Estimated App Store Size来查看体积。在工程中放入2x或3x图片后再次计算。我们通过FontForge对字体做了简化（Element -&gt; Simplify -&gt; Simplify）和取整（Element -&gt; Simplify -&gt; Round -&gt; To Int），结果如下（单位KB）：</p>
<table>
<thead>
<tr>
<th>资源</th>
<th>空工程</th>
<th>2x图</th>
<th>3x图</th>
<th>字体</th>
</tr>
</thead>
<tbody>
<tr>
<td>工程体积</td>
<td>195</td>
<td>249</td>
<td>268</td>
<td>214</td>
</tr>
<tr>
<td>资源体积</td>
<td>0</td>
<td>54</td>
<td>73</td>
<td>19</td>
</tr>
</tbody>
</table>
<p>目前看来替换这部分图片后，仅考虑2x图则替换后体积是之前的<code>35%</code>，如果算上3x图则体积是之前的<code>15%</code>！</p>
<h3>生成图片的性能</h3>
<p>我们对比了字体生成图片和直接使用PNG图片的效率。图片选择了32、64、200三种尺寸的2倍图。统计了两种方法创建1000次UIImageView的耗时，平台为iPhone 5S/iOS8。结果如下（单位：秒）：</p>
<table>
<thead>
<tr>
<th>方法\尺寸</th>
<th>32</th>
<th>64</th>
<th>200</th>
</tr>
</thead>
<tbody>
<tr>
<td>字体生成图片</td>
<td>0.426</td>
<td>0.476</td>
<td>2.085</td>
</tr>
<tr>
<td>PNG图片</td>
<td>0.454</td>
<td>0.441</td>
<td>0.467</td>
</tr>
</tbody>
</table>
<p>PNG图片加载的速度受像素大小影响很小。字体生成图片的方式在32像素的2倍图中，字体生成图片的速度甚至比加载PNG图片还要快。最坏的情况是生成1000张200像素的2倍图耗时达到了2秒多。但是这种情况比较极端，即使有多张大图展示的需求，也可以通过UITableView来做懒加载。而且平均下来每张图耗时2毫秒。总体来看字体生成图片效率还可以接受。</p>
<h3>项目中应用</h3>
<p>目前淘点点iOS插件版中的图标有半数替换为IconFont。新需求用到的图标也会优先采用IconFont。一个典型的应用IconFont的页面比如我的页面。应用每个页面都有的Tabbar的四个图标、列表中的四个彩色图标、头部的四个白色图标和导航栏的消息图标。目前已经上线，读者可以将手机淘宝最新的ipa下载解压，查看Payload/Taobao4iPhone中的文件，就会发现找不到上面提到这几个图标的图片文件。同时会看到LLIconfont.ttf文件，也就是点点使用的字体库。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG4tam9obndvbmcucWJveC5tZS9pbWFnZXMvMjAxNS0wNC0wMy11c2luZy1pY29uLWZvbnQtaW4taW9zLXRhb2RpYW5kaWFuLnBuZw==.jpg"></p>
<p>IconFont项目已经整理开源出来：<a href="https://github.com/JohnWong/IconFont" rel="external nofollow noreferrer">IconFont项目</a>。工程中包含核心代码和Demo，核心功能最低兼容iOS5。已经放到了CocoaPods上，名称是<code>IconFont</code>。</p>
<h2>其他有趣的方案</h2>
<h3>PDF绘制矢量图</h3>
<p>PDF也可以存储矢量图。Xcode6下新建TabViewController后，tab的图标采用的是PDF文件。我们想类似使用PDF图标。<a href="http://martiancraft.com/blog/2014/09/vector-images-xcode6/" rel="external nofollow noreferrer">Using Vector images in Xcode6</a>文章中指出，实际上Xcode6下使用PDF只是在编译时根据PDF生成不同倍数图片，并不在应用中使用矢量图。并且Asset Catalog从iOS7开始才能使用。从兼容性和缩小图片体积的考虑，这种方法没有帮助。</p>
<p><a href="https://github.com/mindbrix/UIImage-PDF" rel="external nofollow noreferrer">UIImage-PDF</a>是Github上收获Star比较多的一个项目，实现了PDF绘制图片的功能，并且没有系统版本兼容的问题。相比与IconFont，PDF方案可以可以存储颜色信息，可以像Sprite一样从一个PDF导出多张图片。但是相比IconFont，占用体积也要大得多。另外发现AI文件直接导出PDF后体积很大，转为SVG后再转为PDF体积会减小一些。目前用一个比较复杂的矢量图转换，PDF的体积与原图的体积大致一样，因此这种方法对体积减小并无帮助。</p>
<h3>字符串绘制矢量图</h3>
<p>Charles Parnot贴出了博文<a href="http://cocoamine.net/blog/2015/03/20/replacing-photoshop-with-nsstring/" rel="external nofollow noreferrer">用NSString替换Photoshop</a>，提供了一种用字符串来保存矢量图的方式。在一个字符的二维数组中通过特定字符的位置在图中勾勒出点、线、贝塞尔曲线等来绘制图片。有了这样的能力就能够保存字体可以保存的图形。这种方法非常新颖有趣。当然局限性也很明显，绘制图形比较困难。和IconFont方案的对比我并没有做，想象那么多图用字符表示出来我就放弃了。可以推断的是，有些图中多个图形的点可能重合，用这种方式会有问题。如果要对图中的点做精细的控制，用这种方案需要将字符数组的尺寸加到很大才可以。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 04:48:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用IconFont减小iOS应用体积的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPXKr1p.html" rel="bookmark">减小js css体积，提高加载速度</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				减小js css体积,提高加载速度 浏览器解析 js 跟 css 他是不用看空行,回车,制表符的.但是一个js跟css文件空行,转行跟制表符却占用一个文件起码15%的体积,美其名曰:缩进.比如 global.js &lt;sciript&gt; var a=1;      if (a){      alert(a); } &lt;/script&gt; 我们minify一下把他弄成 &lt;sciript&gt;var a=1;if(a){alert(a);}&lt;/script&gt; 根本不影响浏览			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbElRAz.html" rel="bookmark">减小Word文件体积小技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用Word生成的文档,每页大概在20KB左右,但用记事本生成的文档,相同的内容只有1KB左右,能让Word文件减减肥吗?下面我们介绍一些减小Word文 1.取消快速保存 当文件打开时,使用快速保存比使用完全保存需要更多的空间.可以在&quot;工具→选项&quot;命令中选择&quot;保存&quot;选项卡,取消&quot;允许快速保存&quot;复选框即可. 2.文件另存 Word在保存DOC文件时,只把后来修改的信息存入,这样即使你删除了文件中的部分内容也会使文件越来越大,如果我们使用&quot;另			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNEVNb.html" rel="bookmark">IconFont-来自字体的图标</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				IconFont IconFont is a way to build lossless images of pure color with font file. 简介 IconFont是一种通过字体文件来构建纯色图的方案.更详细的介绍参见使用IconFont减小iOS应用体积.简单说来其目的是: 减小应用体积,字体文件比图片要小 图标保真缩放,解决2x/3x乃至将来nx图问题 方便更改颜色大小,图片复用 局限性在于只支持纯色图,但是在扁平化的今天纯色图变得越来越多.目前这套方案在点点iOS客户			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ7xB6b.html" rel="bookmark">iOS开发：如何减小应用程序的大小</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Q: 怎样才能让我的程序安装包小一点,让程序的下载和安装更快速? A: 本文收集了一些减小程序安装包大小的相关技巧(当第一次下载和安装程序时).如果是针对升级程序的话,可以看这篇文章(减小iOS应用程序升级时所需下载的大小)(这与第一次安装使用的工作原理有所不同). 开发:如何减小应用程序的大小-&quot;&gt; 检查应用程序 首先是检查.app bundle,看一下程序包里面哪些文件占的空间最大. 在做任何相关优化之前,我们需要做一些权衡.通过权衡,可以知道把优化的重点集中在什么地方.本文提到的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9W0jvz.html" rel="bookmark">网页页面代码体积大小对SEO的影响及优化方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网页页面代码体积大小对seo教程的影响及优化方法 那么一个页面的代码体积应该控制在多大之内呢? 这个似乎没有定论.我建议是控制在35k至100k左右就可以了,当然在保证其他条件的情况下页面越小越好.我们先来澄清下这里的页面体积是一个什么样的概念.有些seo新手可能会问,如果我的页面html源代码有30k,其中页面上还有两张图片,分别为100k和80k,还有一个外部引用的css教程文件,有15k大小,该页面上还放着一个2m的音频文件,那么这个页面体积有多大?多数人承认这个页面大小是30k.认为页面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZEkVOp.html" rel="bookmark">&lbrack;译&rsqb; 我是如何做到在 5 分钟之内将应用大小减少 60&percnt; 的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是[译] 我是如何做到在 5 分钟之内将应用大小减少 60% 的, 原文地址:How you can decrease application size by 60% (In only 5 minutes)? 原文作者:本文已获作者 Keval Patel 授权 译文出自:掘金翻译计划 译者:jifaxu 校对者:gaozp, ZiXYu 我是如何做到在 5 分钟之内将应用大小减少 60% 的 移动设备的资源总是有限的.有限的电量,有限的存储,有限的处理能力,有限的内存,有限的网络带宽-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPm50p.html" rel="bookmark">关于webp图片格式初探</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 不管是 PC 还是移动端,图片一直是流量大头,以苹果公司 Retina 产品为代表的高 PPI 屏对图片的质量提出了更高的要求,如何保证在图片的精细度不降低的前提下缩小图片体积,成为了一个有价值且值得探索的事情. 但如今对于 JPEG.PNG 和 GIF 这些图片格式的优化几乎已经达到了极致, 若想改变现状开辟新局面,便要有釜底抽薪的胆量和气魄,而 Google 给了我们一个新选择:WebP. 对 WebP 的研究缘起于手机 QQ 原创表情商城,由于表情包体积较大,在 2G/3G 的网络环			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyw2Jz.html" rel="bookmark">Flash中字体选择的奥妙</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 Flash 创作时难免会用到一些特殊的字体,而这些字体很可能不被 Flash 所识别,以至于在最后生成的 swf 文件中无法正常显示.解决的办法一般是将文字打碎转换成图形,但这只适用于 Static Text,对于 Dynamic Text 和 Input Text 是行不通的.Flash 本身为此提供了专门的解决办法,一种叫 Embed Fonts,将字体信息嵌入 fla 和 swf 文件中,保证字体最终能够按原样显示:另一种叫 Device Fonts,播放器选用机器上所安装的字体中与原			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpP8X0p.html" rel="bookmark">Flash中选择字体的奥妙</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 Flash 创作时难免会用到一些特殊的字体,而这些字体很可能不被 Flash 所识别,以至于在最后生成的 swf 文件中无法正常显示.解决的办法一般是将文字打碎转换成图形,但这只适用于 Static Text,对于 Dynamic Text 和 Input Text 是行不通的.Flash 本身为此提供了专门的解决办法,一种叫 Embed Fonts,将字体信息嵌入 fla 和 swf 文件中,保证字体最终能够按原样显示:另一种叫 Device Fonts,播放器选用机器上所安装的字体中与原			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgeWAz.html" rel="bookmark" class="title">百度再次告诉我们：站长做好你的用户</a>
					<div>
						相信互联网最近大家谈论最多的就是百度的19亿收购案了,但对于站长来说,大家关注最多的应该就是7月19日的新公告:出售二级域名或目录用于作弊将株连整站的声明.对于这一举措让大家看到了更多,百度越来越注重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPe0lz.html" rel="bookmark" class="title">揭秘SEO之构建网状网站建设</a>
					<div>
						现在在博客里有很多人在议论,怎样建立网状的博客.网状,顾名思义,就是把自己早博客里写的文章用超链接联系起来,最常见的就是用生僻词,或者专业性比较强的词语作为描文本, 之后专门写一篇介绍这个词的文章,把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPdE8p.html" rel="bookmark" class="title">DPC：Creating a DataBound List of Radio Buttons--PART2&lbrack;等级：中&rsqb;</a>
					<div>
						In Part 1 we looked at how to bind a DataReader to a radio button list, but how do we respond to the ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgvJ3b.html" rel="bookmark" class="title">细读那些年 我们一起追过的seo知识</a>
					<div>
						从了解seo到现在也已经过了2年有余了,这么长的时间也经过了搜索引擎一次又一次的算法更新,也看到过很多网站的起起沉沉,当年我们从一个小菜鸟寻找过的那些seo理论知识你还记得多少呢,当初我们一次又一次的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyBO4p.html" rel="bookmark" class="title">空间经常出问题会影响用户体验及网站自身权重</a>
					<div>
						对于服务器稳定性这一块,其实笔者在过去写过一篇文章:王磊博客友情链接说明,同时感谢大家的支持,当时就是由于服务器出了问题,长时间打不开网站,结果个别友情链接被撤,做网站优化做久了,越来越体会到有一个稳 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPE7rz.html" rel="bookmark" class="title">Serv-U Gateway设置说明</a>
					<div>
						说明:这里Serv-U的安装说明就免了哦,在这个环境里,Serv-U是安装在192.168.2.224这台虚拟机里的. 一.Serv-U Gateway网关的安装 1.下载&quot;Serv-U-G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7kKZb.html" rel="bookmark" class="title">MYSQL数库中的MyISAM如何转化为InnoDB</a>
					<div>
						http://dev.mysql.com/doc/refman/5.6/en/converting-tables-to-innodb.html 查出所有表的信息, 显示为MyISAM为MyISAM引擎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bal7BQz.html" rel="bookmark" class="title">如何在网上购物不受骗</a>
					<div>
						尝试着在网上购物的人多起来,网上购物纠纷等问题也慢慢多起来,诸如网络上刻录机变成乌龙茶;网络大卖MP3随身听,结果却是一场空;在网络进行演唱会宣传,消费者购买门票后到现场却只见摊贩,甚至出现冒充网络银 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RPxap.html" rel="bookmark" class="title">增强WebSphere eXtreme Scale的xsadmin</a>
					<div>
						引言 IBM WebSphere eXtreme Scale 可以采用两种方式进行部署: 通过扩充 WebSphere 配置文件安装到现有 WebSphere Application Server N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOw4Bqz.html" rel="bookmark" class="title">探究Lotus Forms中的事件处理&comma;第一部分&colon; 表单对计算功能的支持</a>
					<div>
						Lotus Forms 通过构建动态的电子表单,收集用户信息并将其传递给其他应用系统,以实现业务流程的管理.与纸质表单相比,电子表单的最大优势之一就是能够动态地响应用户活动.如,根据用户输入动态改变背 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RdLrp.html" rel="bookmark" class="title">Dreamweaver怎么检查站点中链接错误</a>
					<div>
						  我们在建立网站时,通常站点下有许多页面,而页面中的超链接可能有上百个甚至更多,这时我们如何检查出有问题的链接呢?今天小编为大家介绍一下在dreamweaver中如何检查站点范围的链接. 在&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrAYPp.html" rel="bookmark" class="title">利用滤镜及色彩叠加制作漂亮的放射光束文字</a>
					<div>
						  教程中的文字效果主要分为两个大的过程:首先需要用滤镜等给文字加上放射效果;然后用渐变或色彩叠加给整体加上色彩即可. 最终效果 1.新建文件输入文本,如图. 2.按ctrl键点击文字图层小窗口,调出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwZVBp.html" rel="bookmark" class="title">qq音乐2015无法登陆账号怎么办</a>
					<div>
						  大家在使用QQ音乐的时候,一般都会注册个人账户,这样可以方便自己的使用.不过,有些时候我们要登陆账号时,发现登陆不了.这是怎么回事呢?别急,小编这就告诉大家. QQ音乐登录失败原因分析: 一.木马 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRZVQp.html" rel="bookmark" class="title">淘宝助理上传数据包没有图片怎么办</a>
					<div>
						  1.一般解压淘宝的数据包会有如下图的文件. 2.然后大家打开淘宝助理,宝贝管理→导入CSV→找到.csv文件. 3.如下图的箭头的操作步骤添加图片→选择要上传的图片,相信卖家都懂的. 4.找到解压 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQRXNz.html" rel="bookmark" class="title">jquery实现图片左右切换的方法&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery实现图片左右切换的方法.分享给大家供大家参考.具体实现方法如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrmrQM.html" rel="bookmark" class="title">Gearmand异步处理就安全了吗？不！</a>
					<div>
						前言 之前使用Gearman的时候,遇到过一个卡顿的问题.今天微博上又有人问我是否遇到过此类问题.这个问题,当时是伯诚老师解决的.我把他的文章搬过来.希望能给遇到此类问题的人一点参考. 问题 使用Ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lXGob.html" rel="bookmark" class="title">【软考视频】只为下一个阶段更好</a>
					<div>
						和J2SE视频相比,软考视频看的过程就比较轻松,更加容易接受.A.B.C三个部分,罗列出来一看,其实只有很少很少的一部分,属于我们没有接触过的.而这些,都属于一些固定的计算或者规则方面的,并不需要我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NDVNM.html" rel="bookmark" class="title">诺基亚将更名为微软移动</a>
					<div>
						根据一封发给供应商的信件,微软计划重新命名 Nokia Oyj 为 Microsoft Mobile Oy.新的子公司将成为微软公司的移动设备部门.信中的内容表示,&quot;因微软和诺基亚交易接近尾 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6oj7z.html" rel="bookmark" class="title">java URL乱码的解决办法&lowbar;java</a>
					<div>
						平常我们都是encode 一次,然后直接接受参数 String para = request.getParameter(paramName);  这是因为容器自动能帮我们解码 (DECODE) 一般来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAVjvM.html" rel="bookmark" class="title">lrc 0&period;2发布 Linux资源编译器</a>
					<div>
						lrc 0.2此版本更新BitBucket的wiki.它提高了错误处理和清理一些代码的能力. lrc 是The Linux Resource Compiler的简称,即Linux资源编译器.在安装和使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlNXjp.html" rel="bookmark" class="title">快上车！攻击全球电视、银行大盗火线追踪、黑客篡改支付金额，雷锋网带你闯进 SyScan 360</a>
					<div>
						       11月24日,如果你在一个晴朗的天气来到上海(天气预报这么说的,错了不要怪我),你应该去今年最后一场盛大的黑客会议--2016 SyScan360国际前瞻信息安全会议上看看. 吃瓜群众也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydaoPb.html" rel="bookmark" class="title">高手請進</a>
					<div>
						问题描述 在調試VS2005中每次調試程序都出現如下錯誤!Errorwhiletryingtorunproject;Unabletostartdebugging 連接控制碼不正確無論Web程序還是是w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rxK5p.html" rel="bookmark" class="title">微博惊现小米手环 小米也要进军可穿戴领域？</a>
					<div>
						[TechWeb报道]虽然小米公司并未正式公布7月新品发布会的召开时间,不过坊间对于小米新品的猜测已经愈演愈烈.根据业界猜测,小米科技将在近期正式推出其支持4G网络的新品小米手机,各界对于小米4的猜测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqeEJp.html" rel="bookmark" class="title">用Jersey构建RESTful服务2--JAVA对象转成XML输出</a>
					<div>
						一. 总体说明 XML和JSON 是最为常用的数据交换格式.本例子演示如何将java对象,转成XML输出. 二.流程 1.在上文的例子中,创建一个包&quot;com.waylau.rest.bean ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn5dAM.html" rel="bookmark" class="title">js获取元素相对窗口位置的实现代码&lowbar;javascript技巧</a>
					<div>
						JS获取元素的offsetTop,offsetLeft等属性 obj.clientWidth //获取元素的宽度 obj.clientHeight //元素的高度 obj.offsetLeft //元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjyaKM.html" rel="bookmark" class="title">自定义成员资格提供程序实现&lpar;membership类&comma;membershipUser类&rpar;</a>
					<div>
						问题描述 早就知道vs2005的成员资格和角色管理功能很强大,可以让我们这些程序员少写很多的代码．这几天没事研究了一下．结果问题就来了．．．membership表中,存储用户信息的字段比较有限,如果客 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNmWrp.html" rel="bookmark" class="title">浅谈PL&sol;SQL批处理语句&colon;BULK COLLECT与FORALL对优化做出的贡献&lowbar;oracle</a>
					<div>
						我们知道PL/SQL程序中运行SQL语句是存在开销的,因为SQL语句是要提交给SQL引擎处理这种在PL/SQL引擎和SQL引擎之间的控制转移叫做上下文却换,每次却换时,都有额外的开销 请看下图: 但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6OwqM.html" rel="bookmark" class="title">was&period;policy 如何设置访问共享文件夹？</a>
					<div>
						问题描述 was6访问共享文件夹\cnbdc01it该如何设置was.policy文件?尝试了设置,但是还是无法访问/*AUTOMATICALLYGENERATEDONMonApr2013:00:46 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdX9xb.html" rel="bookmark" class="title">移动App如何社会化媒体营销</a>
					<div>
						社会化媒体营销(Social media marketing,简称SMM)就是利用社会化网络,微博.博客.视频.论坛.SNS等互联网互动平台媒体来进行营销工作,公共关系和客户服务维护开拓的一种方式,而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgNg2z.html" rel="bookmark" class="title">余额宝跑赢通货膨胀 万元存一年得558元</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 随着余额宝的7日年化收益率逐渐破5 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
